<?php
/**
 * Lottery history tab template
 * 
 * This template can be overridden by copying it to yourtheme/woocommerce/single-product/tabs/lottery-history.php
 * 
 */

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

global $post;

$prizes = wc_lottery_get_lottery_instant_ticket_numbers_prizes_field( $post->ID );

if ( empty( $prizes ) ) return;

$lottery_winers = get_post_meta($post->ID, '_lottery_winners');
$users_names = '';
$use_answers = wc_lottery_use_answers( $post->ID );
$use_ticket_numbers = get_post_meta( $post->ID , '_lottery_use_pick_numbers', true );
$answers = maybe_unserialize( get_post_meta( $post->ID, '_lottery_pn_answers', true ) );
$date_format = get_option( 'date_format' );
$time_format = get_option( 'time_format' );
$lottery_instant_instant_winners = get_post_meta( $post->ID, '_lottery_instant_instant_winners');
$lottery_pick_numbers_random = get_post_meta( $post->ID , '_lottery_pick_numbers_random', true );



?>

<h2><?php echo esc_html( __( 'Instant prizes and winners', 'wc-lottery-pn' ) ); ?></h2>

<table>
	<thead>
		<tr>
			<th><?php _e('Ticket', 'wc-lottery-pn') ?></th>
			<th><?php _e('Prize', 'wc-lottery-pn') ?></th>
			<th><?php _e('Winner', 'wc-lottery-pn') ?></th>
		</tr>
	</thead>

		<?php

		foreach ($prizes as $prize) {
			$winner_found = false;
			$display_name = '';
			if ( $lottery_instant_instant_winners ){
				foreach ($lottery_instant_instant_winners as $winner) {
					if ( $winner['ticket'] == $prize['ticket'] ){
						$winner_found = true;
						$user_data = Wc_Lottery_Pn_Public::lottery_get_user_display_name_by_id( $winner['user_id'] );
						$display_name = $user_data ? $user_data : '';
						break;
					}
				}
			}

			if( $lottery_pick_numbers_random !== 'yes' && $winner_found === false ){
				$prize['ticket'] = '';
			}
			echo '<tr>';
	                echo '<td class="ticket">'. ($prize['ticket'] ? $prize['ticket'] : '-') . '</td>';
	                echo '<td class="prize">'. $prize['prize'] . '</td>';
	                echo '<td class="winner">' . ($display_name ? $display_name : '-') . '</td>';

                echo '</tr>';
        	}


		?>

</table>